--
-- Mod: zzzFS19_GrowthControlAddOn
--
-- Author: Hummel2211
-- email: 
-- @Date: 22.07.2019
-- @Version: 1.0.0.0

	local growthcontrol = FS19_GrowthControl.growthcontrol	
	growthcontrolAddOn = {};
	growthcontrolAddOn.Version = "1.0.0.0";
	growthcontrolAddOn.debug = false;

	
		growthcontrolAddOn.showHud = false;
		growthcontrolAddOn.recalculate	= false;
		growthcontrolAddOn.maxnumfruits = 15;
		growthcontrolAddOn.fruitnames = {[0]="wheat",[1]="grass",[2]="canola",[3]="barley",[4]="maize",[5]="not used",[6]="potato",[7]="sugarBeet",[8]="sunflower",[9]="soybean",[10]="oilseedRadish",[11]="poplar",[12]="not used",[13]="oat",[14]="sugarCane",[15]="cotton"};
		growthcontrolAddOn.fruitEnable = 	{[0]=true		,[1]=true		,[2]=true		,[3]=true		,[4]=true		,[5]=false			,[6]=true		,[7]=true			,[8]=true			,[9]=true		,[10]=true				,[11]=true		,[12]=false		,[13]=true		,[14]=true			,[15]=true};
		growthcontrolAddOn.growthhours	= {};
		growthcontrolAddOn.growthstatetime = {};
		growthcontrolAddOn.growthremtime = {};
		growthcontrolAddOn.literPerSqm	= {};
		growthcontrolAddOn.seedUsagePerSqm = {};
		growthcontrolAddOn.showHelp = true;
		growthcontrolAddOn.weedUpdateFactor = 1.3;
		growthcontrolAddOn.weedUpdateTime = 30000000;
		growthcontrolAddOn.weedRemTime	= 0;
		growthcontrolAddOn.newfruit = false;
		growthcontrolAddOn.Backupfruitnames = {[0]="wheat",[1]="grass",[2]="canola",[3]="barley",[4]="maize",[5]="not used",[6]="potato",[7]="sugarBeet",[8]="sunflower",[9]="soybean",[10]="oilseedRadish",[11]="poplar",[12]="not used",[13]="oat",[14]="sugarCane",[15]="cotton"};



function growthcontrolAddOn.prerequisitesPresent(specializations)
    return true;
end;


function growthcontrolAddOn:hud()
			local uiScale = g_gameSettings:getValue("uiScale");
			growthcontrol.tPos = {};
			growthcontrol.tPos.size = 0.015 * uiScale;				-- TextSize
			growthcontrol.tPos.spacing = 0.003 * uiScale;			-- Spacing
			growthcontrol.tPos.alignment = RenderText.ALIGN_LEFT;	-- Text Alignment
			growthcontrol.tPos.bgoffset = 0.003 * uiScale; 			-- Offset to Background
			growthcontrol.tPos.yoffset = 0.006 * uiScale ; 			-- Offset y-Startpos	
			growthcontrol.tPos.frame = 0.0005 * uiScale; 			-- Frame
			growthcontrol.tPos.h = ((growthcontrol.tPos.size+growthcontrol.tPos.spacing)*growthcontrol.maxnumfruits) + growthcontrol.tPos.size + (2*growthcontrol.tPos.bgoffset); -- height
			growthcontrol.tPos.w = 0.145 * uiScale;	-- width
			growthcontrol.tPos.x = g_currentMission.hud.gameInfoDisplay.weatherBox.overlay.x - growthcontrol.tPos.w; -- x Pos
			growthcontrol.tPos.y = 0.965 -- y Pos
			
			--Hud Overlay main background
			local ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size;
			growthcontrol.tPosBgOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset, ypos , growthcontrol.tPos.w , growthcontrol.tPos.h );
			growthcontrol.tPosBgOverlayId:setColor(0.018, 0.016, 0.015, 0.65);
			
			--Hud Overlay top
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size + growthcontrol.tPos.h;
			growthcontrol.tPosTopOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset - growthcontrol.tPos.frame, ypos , growthcontrol.tPos.w + (growthcontrol.tPos.frame*2) , (growthcontrol.tPos.frame * 3));
			growthcontrol.tPosTopOverlayId:setColor(1, 1, 1, 1);	
			
			--Hud Overlay left
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size;
			growthcontrol.tPosLeOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset - growthcontrol.tPos.frame, ypos , growthcontrol.tPos.frame , growthcontrol.tPos.h);
			growthcontrol.tPosLeOverlayId:setColor(1, 1, 1, 1);
		
			--Hud Overlay right
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size;
			growthcontrol.tPosRiOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset + growthcontrol.tPos.w, ypos , growthcontrol.tPos.frame , growthcontrol.tPos.h);
			growthcontrol.tPosRiOverlayId:setColor(1, 1, 1, 1);
		
			--Hud Overlay bottom
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size - (growthcontrol.tPos.frame * 9);
			growthcontrol.tPosBoOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset - growthcontrol.tPos.frame, ypos , growthcontrol.tPos.w + (growthcontrol.tPos.frame*2) , (growthcontrol.tPos.frame * 9));
			growthcontrol.tPosBoOverlayId:setColor(0.9910, 0.3865, 0.0100, 1);
end


function growthcontrolAddOn:loadMap(name)
	if g_currentMission:getIsServer() then
			for i=0, growthcontrolAddOn.maxnumfruits do				
				if (growthcontrolAddOn.fruitEnable[i] ~= false) then
					growthcontrolAddOn.growthhours[i] = growthcontrol.growthhours[i];			
					growthcontrolAddOn.literPerSqm[i] = growthcontrol.literPerSqm[i];			
					growthcontrolAddOn.seedUsagePerSqm[i] = growthcontrol.seedUsagePerSqm[i];	
				end;
			end;
	
		
			local savegameIndex = g_currentMission.missionInfo.savegameIndex;
			local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
			if savegameFolderPath == nil then
				savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
			end;

			if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
				if fileExists(savegameFolderPath .. '/growthcontrolAddOn.xml') then
					local key = "growthcontrolAddOn";
					local xmlFile = loadXMLFile("growthcontrolAddOn", savegameFolderPath .. "/growthcontrolAddOn.xml", key);
					local i = 0
					table.remove(growthcontrol.fruitnames)
				
					while true do
						local pruefe = ""
						local pruefe1 = ""
						if hasXMLProperty(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#name") then
							pruefe = getXMLString(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#name");
						else
							break;
						end;
						if hasXMLProperty(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#name") then
							pruefe1 = getXMLString(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#name");
						end;			
						if pruefe == pruefe1 then
							growthcontrolAddOn.fruitnames[i] = getXMLString(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#name");
							growthcontrolAddOn.fruitEnable[i] = getXMLBool(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#fruitEnable");	
						else
							newfruit = true
							local test = g_fruitTypeManager.nameToIndex[string.upper(pruefe)]
							if test ~= nil then
								growthcontrolAddOn.fruitnames[i] = pruefe;
								growthcontrolAddOn.fruitEnable[i] = true;								
								local frName = growthcontrolAddOn.fruitnames[i];
								if (frName ~= nil) and (frName ~= "not used") then
									local frIndex = g_fruitTypeManager.nameToIndex[string.upper(frName)];
									if (frIndex ~= nil) then
										growthcontrol.growthstatetime[i] = g_fruitTypeManager.fruitTypes[frIndex].growthStateTime
										growthcontrol.growthhours[i] = growthcontrol.growthstatetime[i] / 3.6e6;
										growthcontrol.literPerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].literPerSqm;
										growthcontrol.seedUsagePerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].seedUsagePerSqm;
									end;								
									if (growthcontrol.growthstatetime[i] ~= nil) then
										growthcontrol.growthremtime[i] = 1;			
										growthcontrol.growthremtime[i] = (growthcontrol.growthremtime[i] * growthcontrol.growthstatetime[i]) / 60000;
									end;
								end;
							else
								growthcontrolAddOn.fruitnames[i] = pruefe;
								growthcontrolAddOn.fruitEnable[i] = false;
							end;
						end;
					growthcontrol.maxnumfruits = i;	
					i = i + 1;					
					end;	
				end;
			end;	
		


			for i=0, growthcontrol.maxnumfruits do
				if growthcontrolAddOn.fruitEnable[i] ~= false then
					print("-->>   " .. "Registriert:: " .. "index:: " .. tostring(i) .. ", fruitnames:: " .. tostring(growthcontrolAddOn.fruitnames[i]) .. ", fruitEnable:: " .. tostring(growthcontrolAddOn.fruitEnable[i]))
					growthcontrol.fruitnames[i] = growthcontrolAddOn.fruitnames[i]
				else
					print("-->>   " .. "Registriert:: " .. "index:: " .. tostring(i) .. ", fruitnames:: " .. tostring(growthcontrolAddOn.fruitnames[i]) .. ", fruitEnable:: " .. tostring(growthcontrolAddOn.fruitEnable[i]))
					growthcontrol.fruitnames[i] = "not used"
				end;
			end;
		
	
			local uiScale = g_gameSettings:getValue("uiScale");
			growthcontrol.tPos = {};
			growthcontrol.tPos.size = 0.015 * uiScale;				-- TextSize
			growthcontrol.tPos.spacing = 0.003 * uiScale;			-- Spacing
			growthcontrol.tPos.alignment = RenderText.ALIGN_LEFT;	-- Text Alignment
			growthcontrol.tPos.bgoffset = 0.003 * uiScale; 			-- Offset to Background
			growthcontrol.tPos.yoffset = 0.006 * uiScale ; 			-- Offset y-Startpos	
			growthcontrol.tPos.frame = 0.0005 * uiScale; 			-- Frame
			growthcontrol.tPos.h = ((growthcontrol.tPos.size+growthcontrol.tPos.spacing)*growthcontrol.maxnumfruits) + growthcontrol.tPos.size + (2*growthcontrol.tPos.bgoffset); -- height
			growthcontrol.tPos.w = 0.145 * uiScale;	-- width
			growthcontrol.tPos.x = g_currentMission.hud.gameInfoDisplay.weatherBox.overlay.x - growthcontrol.tPos.w; -- x Pos
			growthcontrol.tPos.y = 0.965 -- y Pos
			
			--Hud Overlay main background
			local ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size;
			growthcontrol.tPosBgOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset, ypos , growthcontrol.tPos.w , growthcontrol.tPos.h );
			growthcontrol.tPosBgOverlayId:setColor(0.018, 0.016, 0.015, 0.65);
			
			--Hud Overlay top
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size + growthcontrol.tPos.h;
			growthcontrol.tPosTopOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset - growthcontrol.tPos.frame, ypos , growthcontrol.tPos.w + (growthcontrol.tPos.frame*2) , (growthcontrol.tPos.frame * 3));
			growthcontrol.tPosTopOverlayId:setColor(1, 1, 1, 1);	
			
			--Hud Overlay left
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size;
			growthcontrol.tPosLeOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset - growthcontrol.tPos.frame, ypos , growthcontrol.tPos.frame , growthcontrol.tPos.h);
			growthcontrol.tPosLeOverlayId:setColor(1, 1, 1, 1);
		
			--Hud Overlay right
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size;
			growthcontrol.tPosRiOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset + growthcontrol.tPos.w, ypos , growthcontrol.tPos.frame , growthcontrol.tPos.h);
			growthcontrol.tPosRiOverlayId:setColor(1, 1, 1, 1);
		
			--Hud Overlay bottom
			ypos = growthcontrol.tPos.y - growthcontrol.tPos.h + growthcontrol.tPos.size - (growthcontrol.tPos.frame * 9);
			growthcontrol.tPosBoOverlayId = Overlay:new("dataS2/menu/white.dds", growthcontrol.tPos.x - growthcontrol.tPos.bgoffset - growthcontrol.tPos.frame, ypos , growthcontrol.tPos.w + (growthcontrol.tPos.frame*2) , (growthcontrol.tPos.frame * 9));
			growthcontrol.tPosBoOverlayId:setColor(0.9910, 0.3865, 0.0100, 1);
		
			
			--load Savegame
			local savegameIndex = g_currentMission.missionInfo.savegameIndex;
			local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
			if savegameFolderPath == nil then
				savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
			end;
	
			if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
				if fileExists(savegameFolderPath .. '/growthcontrolAddOn.xml') and newfruit == false then
					local key = "growthcontrolAddOn";
					local xmlFile = loadXMLFile("growthcontrolAddOn", savegameFolderPath .. "/growthcontrolAddOn.xml", key);
					if xmlFile ~= nil then
						for i=0, growthcontrol.maxnumfruits do
							local frName = growthcontrol.fruitnames[i];
							if (frName ~= nil) and (frName ~= "not used") and growthcontrolAddOn.fruitEnable[i] ~= false then
							--if growthcontrolAddOn.fruitEnable[i] ~= false and growthcontrolAddOn.fruitEnable[i] ~= nil then
								growthcontrol.growthhours[i] = getXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#hours");
								growthcontrol.growthstatetime[i] = growthcontrol.growthhours[i]*3.6e6;
								growthcontrol.literPerSqm[i] = getXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#literPerSqm");
								growthcontrol.seedUsagePerSqm[i] = getXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#seedUsagePerSqm");
								local frIndex = g_fruitTypeManager.nameToIndex[string.upper(frName)];
								if (frIndex ~= nil) then
									g_fruitTypeManager.fruitTypes[frIndex].growthStateTime = growthcontrol.growthstatetime[i];
									if (growthcontrol.literPerSqm[i] ~= nil) and (growthcontrol.literPerSqm[i] >= 0.1) then
										g_fruitTypeManager.fruitTypes[frIndex].literPerSqm = growthcontrol.literPerSqm[i];
									else
										growthcontrol.literPerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].literPerSqm;
									end;
									if (growthcontrol.seedUsagePerSqm[i] ~= nil) and (growthcontrol.seedUsagePerSqm[i] >= 0.005) then
										g_fruitTypeManager.fruitTypes[frIndex].seedUsagePerSqm = growthcontrol.seedUsagePerSqm[i];
									else
										growthcontrol.seedUsagePerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].seedUsagePerSqm;
									end;
								end;
							end;
						end;
						growthcontrol.showHelp = getXMLBool(xmlFile, "growthcontrolAddOn.setting" .. "#showHelp");
						growthcontrol.weedUpdateFactor = getXMLFloat(xmlFile, "growthcontrolAddOn.setting" .. "#weedGrowthDelayFactor");
					end;
				delete(xmlFile); 
			else	
				for i=0, growthcontrol.maxnumfruits do
					local frName = growthcontrol.fruitnames[i];
					if (frName ~= nil) and (frName ~= "not used") then
						local frIndex = g_fruitTypeManager.nameToIndex[string.upper(frName)];
						if (frIndex ~= nil) then
							growthcontrol.growthstatetime[i] = g_fruitTypeManager.fruitTypes[frIndex].growthStateTime;
							growthcontrol.growthhours[i] = growthcontrol.growthstatetime[i] / 3.6e6;
							growthcontrol.literPerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].literPerSqm;
							growthcontrol.seedUsagePerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].seedUsagePerSqm;
						end
						if growthcontrol.debug then					
							print("--- growthcontrol Debug ... growthcontrol:loadMap(frIndex["..tostring(frIndex).."]/fruit["..growthcontrol.fruitnames[i].."]/growthhours["..growthcontrol.growthhours[i].."]/litersPerSqm["..growthcontrol.literPerSqm[i].."]/seedUsagePerSqm["..growthcontrol.seedUsagePerSqm[i].."] ---");
						end;	
					end;
				end;
			end;
	
			--read values of fruit_density_growthState.xml and calculate remaining growthtime in minutes
			if fileExists(savegameFolderPath .. '/fruit_density_growthState.xml') then
				local key = "foliageCropsUpdater";
				local xmlFile = loadXMLFile("fruit_density_growthState", savegameFolderPath .. "/fruit_density_growthState.xml", key);
				local j = 0;
				for i=0, growthcontrol.maxnumfruits do
					local frName = growthcontrol.fruitnames[i];
					if (frName ~= nil) and (frName ~= "not used") then
						if (i == 0) then
							j = i;
						else
							j = j + 1;
						end;
						growthcontrol.growthremtime[i] = getXMLFloat(xmlFile, "foliageCropsUpdater.cropsState("..j..")#normalizedGrowthTimer");
						if growthcontrol.debug then
							print("--- growthcontrol Debug ... readed cropsState["..tostring(i).."] normalizedGrowthTimer="..tostring(growthcontrol.growthremtime[i]).." ---");
						end;					
						if (growthcontrol.growthremtime[i] ~= nil) and (growthcontrol.growthstatetime[i] ~= nil) then
							growthcontrol.growthremtime[i] = (growthcontrol.growthremtime[i] * growthcontrol.growthstatetime[i]) / 60000;
						else
							growthcontrol.growthremtime[i] = 1;
						end;				
						if growthcontrol.debug then
							print("--- growthcontrol Debug ... calculated Remaining Time["..growthcontrol.fruitnames[i].."]= "..(growthcontrol.growthremtime[i]/60).." hours ---");
						end;
					end;
				end;
				delete(xmlFile);						
			end;
			
			--read values of weed_growthState.xml and set growthtime of weed
			if g_currentMission.missionInfo.weedsEnabled then
				local weedGrowthStateTime = 30000000 * ((growthcontrol.growthhours[0]/6.67) * growthcontrol.weedUpdateFactor); --standard grothhours wheat=6.67
				if (weedGrowthStateTime > 30000000) then
					g_fruitTypeManager.fruitTypes[g_fruitTypeManager.nameToIndex["WEED"]].weed.growthStateTime = weedGrowthStateTime;
					if growthcontrol.debug then
						print("--- growthcontrol Debug ... set weedGrowthStateTime["..tostring(weedGrowthStateTime).."], weedUpdateFactor["..tostring(growthcontrol.weedUpdateFactor).."] ---");
					end;				
				end;
				
				if fileExists(savegameFolderPath .. '/weed_growthState.xml') then
					local key = "currentUpdateTime";
					local xmlFile = loadXMLFile("weed_growthState", savegameFolderPath .. "/weed_growthState.xml", key);
					local readUpdateTime = getXMLFloat(xmlFile, "terrainDetailUpdater#currentUpdateTime");
					if (readUpdateTime ~= nil) then
						growthcontrol.weedUpdateTime = getXMLFloat(xmlFile, "terrainDetailUpdater#currentUpdateTime");
					end;
					if growthcontrol.debug then
						print("--- growthcontrol Debug ... weed currentUpdateTime["..tostring(growthcontrol.weedUpdateTime).."] ---");
					end;
					delete(xmlFile);
				end; 
			
				growthcontrol.weedRemTime = ((growthcontrol.weedUpdateTime / 60000) * g_currentMission.missionInfo.timeScale);
				if growthcontrol.debug then
					print("--- growthcontrol Debug ... weed RemainingTime["..tostring(growthcontrol.weedRemTime / 60).." h], actual timescale["..tostring(g_currentMission.missionInfo.timeScale).."] ---");
				end;
			end;
		else
			for i=0, growthcontrol.maxnumfruits do
				local frName = growthcontrol.fruitnames[i];
				if (frName ~= nil) and (frName ~= "not used") then
					local frIndex = g_fruitTypeManager.nameToIndex[string.upper(frName)];
					if (frIndex ~= nil) then
						growthcontrol.growthstatetime[i] = g_fruitTypeManager.fruitTypes[frIndex].growthStateTime
						growthcontrol.growthhours[i] = growthcontrol.growthstatetime[i] / 3.6e6;
						growthcontrol.literPerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].literPerSqm;
						growthcontrol.seedUsagePerSqm[i] = g_fruitTypeManager.fruitTypes[frIndex].seedUsagePerSqm;
					end;
					if growthcontrol.debug then					
						print("--- growthcontrol Debug ... growthcontrol:loadMap(frIndex["..tostring(frIndex).."]/fruit["..growthcontrol.fruitnames[i].."]/growthhours["..growthcontrol.growthhours[i].."]/litersPerSqm["..growthcontrol.literPerSqm[i].."]/seedUsagePerSqm["..growthcontrol.seedUsagePerSqm[i].."]");
					end;								
					if (growthcontrol.growthstatetime[i] ~= nil) then
						growthcontrol.growthremtime[i] = 1;			
						growthcontrol.growthremtime[i] = (growthcontrol.growthremtime[i] * growthcontrol.growthstatetime[i]) / 60000;
					end;
					if growthcontrol.debug then
						print("--- growthcontrol Debug ... calculated Remaining Time["..growthcontrol.fruitnames[i].."]= "..(growthcontrol.growthremtime[i]/60).." hours ---");			
					end
				end;
			end;		
		end;
		FSBaseMission.saveSavegame = Utils.appendedFunction(FSBaseMission.saveSavegame, growthcontrolAddOn.saveSettings);	
	end;	
end;


function growthcontrolAddOn:saveSettings()
		local savegameIndex = g_currentMission.missionInfo.savegameIndex;
		local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;
		local key = "growthcontrolAddOn"; 
		local xmlFile = createXMLFile("growthcontrolAddOn", savegameFolderPath .. "/growthcontrolAddOn.xml", key);
		
		if fileExists(savegameFolderPath .. '/growthcontrolAddOn.xml') then	
			for i=0, growthcontrol.maxnumfruits do
				if (growthcontrolAddOn.fruitEnable[i] ~= false) then
					setXMLInt(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#index",i);
					setXMLString(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#name",growthcontrolAddOn.fruitnames[i]);
					setXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#hours",growthcontrol.growthhours[i]);
					setXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#literPerSqm",growthcontrol.literPerSqm[i]);
					setXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#seedUsagePerSqm",growthcontrol.seedUsagePerSqm[i]);
					setXMLBool(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#fruitEnable",growthcontrolAddOn.fruitEnable[i]);
				else
					setXMLInt(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#index",i);
					setXMLString(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#name",growthcontrolAddOn.fruitnames[i]);
					setXMLBool(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#fruitEnable",growthcontrolAddOn.fruitEnable[i]);
				end;
				setXMLInt(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#index",i);
				setXMLString(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#name",growthcontrolAddOn.fruitnames[i]);
				setXMLString(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#foliageXmlId","xxx");
			end;
		else
			for i=0, growthcontrol.maxnumfruits do
				
				if (growthcontrolAddOn.fruitEnable[i] ~= false) then
					setXMLInt(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#index",i);
					setXMLString(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#name",growthcontrolAddOn.fruitnames[i]);
					setXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#hours",growthcontrol.growthhours[i]);
					setXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#literPerSqm",growthcontrol.literPerSqm[i]);
					setXMLFloat(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#seedUsagePerSqm",growthcontrol.seedUsagePerSqm[i]);
					setXMLBool(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#fruitEnable",growthcontrolAddOn.fruitEnable[i]);
				else
					setXMLInt(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#index",i);
					setXMLString(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#name",growthcontrolAddOn.fruitnames[i]);
					setXMLBool(xmlFile, "growthcontrolAddOn.growthcontrol.fruit("..i..")#fruitEnable",growthcontrolAddOn.fruitEnable[i]);
				end;
				setXMLInt(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#index",i);
				setXMLString(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#name",growthcontrolAddOn.fruitnames[i]);
				setXMLString(xmlFile, "growthcontrolAddOn.FoliageMultiLayer.FoliageType("..i..")#foliageXmlId","xxx");
			end;		
		end	
		
	setXMLBool(xmlFile, "growthcontrolAddOn.setting" .. "#showHelp",growthcontrol.showHelp);
	setXMLFloat(xmlFile, "growthcontrolAddOn.setting" .. "#weedGrowthDelayFactor",growthcontrol.weedUpdateFactor);
	
	saveXMLFile(xmlFile);
	delete(xmlFile);		
	

--####################################################################################

	
	 myKey = "growthcontrol"; 
	 myXmlFile = createXMLFile("growthcontrol", savegameFolderPath .. "/growthcontrol.xml", myKey);
	for i=0, growthcontrolAddOn.maxnumfruits do
		if (growthcontrolAddOn.Backupfruitnames[i] ~= "not used") then
			setXMLFloat(myXmlFile, "growthcontrol.fruit("..i..")#hours",growthcontrolAddOn.growthhours[i]);
			setXMLFloat(myXmlFile, "growthcontrol.fruit("..i..")#literPerSqm",growthcontrolAddOn.literPerSqm[i]);
			setXMLFloat(myXmlFile, "growthcontrol.fruit("..i..")#seedUsagePerSqm",growthcontrolAddOn.seedUsagePerSqm[i]);
		else
			setXMLString(myXmlFile, "growthcontrol.fruit("..i..")#name","not used");
		end;
	end;
	setXMLBool(myXmlFile, "growthcontrol.setting" .. "#showHelp",growthcontrolAddOn.showHelp);
	setXMLFloat(myXmlFile, "growthcontrol.setting" .. "#weedGrowthDelayFactor",growthcontrolAddOn.weedUpdateFactor);
	
	saveXMLFile(myXmlFile);
	delete(myXmlFile);		

	growthcontrol.recalculate = true;
end;



-- *****+++++*****+++++ Multiplayer *****+++++*****+++++
local origServerSendObjects = Server.sendObjects;

function Server:sendObjects(connection, x, y, z, viewDistanceCoeff)
	connection:sendEvent(gcaMultiplayerJoinEvent:new());
	return origServerSendObjects(self, connection, x, y, z, viewDistanceCoeff);
end;

gcaMultiplayerJoinEvent = {};
gcaMultiplayerJoinEvent_mt = Class(gcaMultiplayerJoinEvent, Event);
InitEventClass(gcaMultiplayerJoinEvent, 'gcaMultiplayerJoinEvent');

function gcaMultiplayerJoinEvent:emptyNew()
	local self = Event:new(gcaMultiplayerJoinEvent_mt);
	self.className = 'growthcontrolAddOn.gcaMultiplayerJoinEvent';
	return self;
end;

function gcaMultiplayerJoinEvent:new()
	local self = gcaMultiplayerJoinEvent:emptyNew()
	return self;
end;

-- Send data from the server to the client gcaMultiplayerJoinEvent

function gcaMultiplayerJoinEvent:writeStream(streamId, connection)
	if not connection:getIsServer() then
		streamWriteInt8(streamId, growthcontrol.maxnumfruits);	
		for i=0, growthcontrol.maxnumfruits do
			streamWriteString(streamId, growthcontrol.fruitnames[i]);
			local frName = growthcontrol.fruitnames[i];
			if (frName ~= nil) and (frName ~= "not used") then		
				streamWriteFloat32(streamId, growthcontrol.growthremtime[i]);
				streamWriteFloat32(streamId, growthcontrol.growthstatetime[i]);
				if growthcontrol.debug then
					print("--- growthcontrol Debug ... sending data to joining client: "..tostring(growthcontrol.growthremtime[i]).." , "..tostring(growthcontrol.growthstatetime[i]).." ---");
				end;				
			end;
		end;
		streamWriteFloat32(streamId, growthcontrol.weedUpdateFactor);
		streamWriteFloat32(streamId, growthcontrol.weedRemTime);
		if growthcontrol.debug then
			print("--- growthcontrol Debug ... sending data to joining client: weedUpdateFactor["..tostring(growthcontrol.weedUpdateFactor).."], weed RemainingTime["..tostring(growthcontrol.weedRemTime / 60).."h] ---");
		end;		
	end;
end;

-- Read from the server gcaMultiplayerJoinEvent

function gcaMultiplayerJoinEvent:readStream(streamId, connection)
	if connection:getIsServer() then
		growthcontrol.maxnumfruits = streamReadInt8(streamId);
		for i=0, growthcontrol.maxnumfruits do
			growthcontrol.fruitnames[i] = streamReadString(streamId);
			local frName = growthcontrol.fruitnames[i];
			if (frName ~= nil) and (frName ~= "not used") then
				growthcontrol.growthremtime[i] = streamReadFloat32(streamId);
				growthcontrol.growthstatetime[i] = streamReadFloat32(streamId);
				if growthcontrol.debug then
					print("--- growthcontrol Debug ... reading data from server: "..tostring(growthcontrol.growthremtime[i]).." , "..tostring(growthcontrol.growthstatetime[i]).." ---");
				end;				
			end;
		end;	
	end;
	growthcontrol.weedUpdateFactor = streamReadFloat32(streamId);
	growthcontrol.weedRemTime = streamReadFloat32(streamId);
	growthcontrolAddOn:hud()
	if growthcontrol.debug then
		print("--- growthcontrol Debug ... reading data from server: weedUpdateFactor["..tostring(growthcontrol.weedUpdateFactor).."], weed RemainingTime["..tostring(growthcontrol.weedRemTime / 60).."h] ---");
	end;	
end;


addModEventListener(growthcontrolAddOn);